var ce = document.createElement.bind(document)

var Carousel = window.Carousel = function (items) {
  this.steper = new Steper(items)
  this.frame = buildElement()
  var indicator = this.frame.getElementsByClassName('indicator')[0]
  indicator.appendChild(buildIndicator.call(this))
  var inner = this.frame.getElementsByClassName('inner')[0];
  var image = document.createElement('img')
  image.width = 600
  image.height = 480
  image.src = this.steper.getCurrent()
  inner.appendChild(image)
  this.steper.onNext(function(item) {
    image.src = item
  })
  this.steper.onPrev(function(item) {
    image.src = item
  })

  var prev = this.frame.getElementsByClassName('prev')[0]
  prev.addEventListener('click', function () {
    this.steper.prev()
    indicator.replaceChild(buildIndicator.call(this), indicator.firstChild)
  }.bind(this));

  var next = this.frame.getElementsByClassName('next')[0]
  next.addEventListener('click', function () {
    this.steper.next()
    indicator.replaceChild(buildIndicator.call(this), indicator.firstChild)
  }.bind(this));

  function buildIndicator() {
    var whiteCircle = '&#9675;'
    var blackCircle = '&#9679;'
    var div = ce('div')
    new Array(items.length).fill('').forEach(function(c, i) {
      var span = ce('span')
      span.innerHTML = i == this.steper.getCurrentPos() ? blackCircle : whiteCircle
      span.addEventListener('click', function() {
        this.steper.goTo(i)
      }.bind(this))
      div.appendChild(span)
    }.bind(this))
    return div
  }
}

Carousel.prototype.render = function(element) {
  element.appendChild(this.frame)
}

function buildElement () {
  var frame = ce('div')
  frame.classList.add('frame')
  var inner = ce('div')
  inner.classList.add('inner')
  var control = ce('div')
  control.classList.add('control')
  var prev = ce('div')
  prev.classList.add('prev')
  var next = ce('div')
  next.classList.add('next')
  var lt = ce('span')
  lt.innerHTML = '&#9664'
  prev.appendChild(lt)
  var gt = ce('span')
  gt.innerHTML = '&#9654'
  next.appendChild(gt)
  var indicator = ce('div')
  indicator.classList.add('indicator')
  control.appendChild(prev)
  control.appendChild(next)
  control.appendChild(indicator)
  frame.appendChild(inner)
  frame.appendChild(control)
  return frame
}

